SynthDef.new("MidiDrum", { |vel=100, x=64, y=64,out=0|
	// resonant snare sound
	var sndbuf= Buffer.readChannel(s, "/home/andy/Desktop/music/supercollider/samples/84001__sandyrb__KBSD_C42_VELOCITY9.wav", channels:0);
        var rq=10**((16-y) / 41);
	var env,amp;
	var noteMin=30;//54;
	var noteMax=128;//66;
	var note=(x*(noteMax-noteMin)/127)+noteMin;
   //note=(note/12).floor*12;
	vel=vel+((127-note)/40)+((127-y)/50);
   amp=((vel-96)/3).dbamp;
	env=EnvGen.kr(Env.triangle(1,4),1,doneAction:2);
	Out.ar(out,amp*env*Pan2.ar(RLPF.ar(PlayBuf.ar(1,sndbuf), note.floor.midicps, rq  ), 0) );
	} ).store;

SynthDef.new("MidiDrum", { |vel=100, x=64, y=64,out=0|
	// synth drum with pink noise, comb delay line and low pass filter.
   var rq=10**((y-40) / 41);
	var env,amp;
	var noteMin=55; // 200Hz
	var noteMax=128;//66;
	var note=(x*(noteMax-noteMin)/127)+noteMin;
   var baseFreq=100;
   amp=16*((vel-96)/3).dbamp;
	env=EnvGen.kr(Env.perc(0.01,0.5,1),1,doneAction:2);
	Out.ar(out,amp*env*Pan2.ar(LPF.ar(CombC.ar(PinkNoise.ar(0.1),1,1/baseFreq,rq),note.midicps), 0) );
	} ).store;

SynthDef.new("MidiDrum", { |vel=100, x=64, y=64,out=0|
	// synth drum with chaotic crackle, comb delay line and low pass filter.
   var rq=10**((y-70) / 41);
	var env,amp;
	var noteMin=55; // 200Hz
	var noteMax=128;//66;
	var note=(x*(noteMax-noteMin)/127)+noteMin;
   var baseFreq=100;
   amp=20*((vel-96)/3).dbamp;
	env=EnvGen.kr(Env.perc(0.01,0.3,1),1,doneAction:2);
	Out.ar(out,amp*env*Pan2.ar(LPF.ar(CombC.ar(Crackle.ar(1.5,0.1),1,1/baseFreq,rq),note.midicps), 0) );
	} ).store;

SynthDef.new("MidiDrum", { |vel=100, x=64, y=64,out=0|
	// crackle noise with LPF.
   var chaos=(y/128)+1;
	var env,amp;
	var noteMin=55; // 200Hz
	var noteMax=128;//66;
	var note=(x*(noteMax-noteMin)/127)+noteMin;
   var baseFreq=100;
   amp=16*((vel-96)/3).dbamp;
	env=EnvGen.kr(Env.perc(0.01,0.5,1),1,doneAction:2);
	Out.ar(out,amp*env*Pan2.ar(LPF.ar(Crackle.ar(chaos,0.1),note.midicps), 0) );
	} ).store;

SynthDef.new("MidiDrum", { |vel=100, x=64, y=64,out=0|
	// resonant snare sound
	var sndbuf= Buffer.readChannel(s, "/home/andy/Desktop/music/supercollider/samples/84001__sandyrb__KBSD_C42_VELOCITY9.wav", channels:0);
        var rq=10**((32-y) / 41);
	var env,amp;
	var noteMin=86;//54;
	var noteMax=98;//66;
	var note=(x*(noteMax-noteMin)/127)+noteMin;
   //note=(note/12).floor*12;
	vel=vel+((127-note)/40)+((127-y)/50);
        amp=((vel-96)/3).dbamp;
	env=EnvGen.kr(Env.triangle(1,4),1,doneAction:2);
	Out.ar(out,amp*env*Pan2.ar(RLPF.ar(PlayBuf.ar(1,sndbuf), note.floor.midicps, rq  ), 0) );
	} ).store;


SynthDef.new("MidiDrum", { |vel=100, x=64, y=64,out=0|
	// interfering oscillators.
	var env,amp;
	var noteMin=54;
	var noteMax=66;
	var note=(x*(noteMax-noteMin)/128)+noteMin;
	var noteMiny=66;
	var noteMaxy=78;
	var notey=(y*(noteMaxy-noteMiny)/128)+noteMiny;
	//vel=vel+((128-note)/50)+((128-y)/50);
        amp=((vel-96)/3).dbamp;
	env=EnvGen.kr(Env.perc(0.1,0.5,1),1,doneAction:2);
	Out.ar(out,amp*env*Pan2.ar(SinOsc.ar(note.midicps)*SinOsc.ar(notey.midicps), 0) );
	} ).store;


SynthDef.new("MidiDrum", { |vel=100, x=64, y=64,out=0|
	// icebreak with filters
	var sndbuf= Buffer.readChannel(s, "/home/andy/Desktop/music/supercollider/samples/breaking-ice/18180_Bram_icebreak6.wav", channels:0);
        var rq=10**((32-y) / 64);
	var env,amp;
	var noteMin=32;
	var noteMax=128;
	var note=(x*(noteMax-noteMin)/128)+noteMin;
	vel=vel+((128-note)/50)+((128-y)/50);
        amp=((vel-96)/3).dbamp;
	env=EnvGen.kr(Env.triangle(0.8,1),1,doneAction:2);
	Out.ar(out,amp*env*Pan2.ar(RLPF.ar(PlayBuf.ar(1,sndbuf), note.floor.midicps, rq  ), 0) );
	} ).store;


SynthDef.new("MidiDrum", { |vel=100, x=64, y=64,out=0|
	// buzz with RLPF
        var rq=0.01;
	var env,amp;
	var noteMin=44;
	var noteMax=80;
	var rate=y+20;
	var note=(x*(noteMax-noteMin)/128)+noteMin;
	//vel=vel+((128-note)/50)+((128-y)/50);
        amp=((vel-96)/3).dbamp;
	env=EnvGen.kr(Env.triangle(1,0.5),1,doneAction:2);
	Out.ar(out,amp*env*Pan2.ar(RLPF.ar(Impulse.ar(rate), note.midicps, rq  ), 0) );
	} ).store;

SynthDef.new("MidiDrum", { |vel=100, x=64, y=64,out=0|
	// resonant harmonic oscillator with DynKlank.
   var baseFreq=200, freqOffset=15, harmonics=20, ampPower= -1, decayPower= -0.5;
   var baseDecay=1,baseAmp=0.3;
   var harmFreqs=Array.new(harmonics);
   var harmAmps=Array.new(harmonics);
   var harmDecays=Array.new(harmonics);
   decayPower=((x/128)*2)-1;
   ampPower=((y/128)*2)-2.5;
   (harmonics-1).do({|i|
      var harm=i+1;
      harmFreqs.add(harm);
      harmAmps.add(harm**ampPower);
      harmDecays.add(harm**decayPower);
      });
	Out.ar(out,Pan2.ar(EnvGen.kr(Env.perc(0.02,5,1,'linear'),1.0,doneAction:2)*DynKlank.ar(`[harmFreqs,harmAmps,harmDecays],EnvGen.kr(Env.perc(0,0.01,1,'linear') )*PinkNoise.ar(0.05),baseFreq,freqOffset,baseDecay),0,baseAmp) );
	} ).store;


// Following SynthDefs are based on "synth secrets" in the magazine Sound On Sound.
// See: http://www.soundonsound.com/sos/allsynthsecrets.htm

SynthDef.new("MidiDrum", { |vel=100, x=64, y=64, out=0|
   // kettle drum patch from synth secrets.
   var baseFreq=150, baseDelay=5, baseAmp=0.5, attack=0.01;
   var freq11=baseFreq, amp11=1, del11=baseDelay*0.45;
   var freq21=baseFreq*1.5, amp21=0.8, del21=baseDelay*0.73;
   var freq31=baseFreq*1.98, amp31=0.6, del31=baseDelay*0.91;
   var freq41=baseFreq*2.44, amp41=0.2, del41=baseDelay*0.84;
   var freqRing1=100, freqRing2=87, delRing=baseDelay*0.05,ampRing=0.5;
   var env11,env21,env31,env41,harmSig,ringSig,envRing;
   env11=EnvGen.kr(Env.perc(attack,del11,amp11),1);
   env21=EnvGen.kr(Env.perc(attack,del21,amp21),1);
   env31=EnvGen.kr(Env.perc(attack,del31,amp31),1,doneAction:2);
   env41=EnvGen.kr(Env.perc(attack,del41,amp41),1);
   envRing=EnvGen.kr(Env.perc(attack,delRing,ampRing),1);
   harmSig=env11*SinOsc.ar(freq11)+env21*SinOsc.ar(freq21)+env31*SinOsc.ar(freq31)+env41*SinOsc.ar(freq41);
   ringSig=envRing*HPF.ar(Saw.ar(freqRing1)*Saw.ar(freqRing2),baseFreq);
   Out.ar(out,Pan2.ar(baseAmp*(ringSig+harmSig),0));
   } ).store;

SynthDef.new("MidiDrum", { |vel=100, x=64, y=64, out=0|
   // bass drum patch from synth secrets.
   var baseFreq=50, baseDelayMin=0.1, baseDelayMax=3, baseAmp=1, attack=0.01;
   var baseFreqMod=1, harmLPFreqMin=baseFreq, harmLPFreqMax=baseFreq*10;
   var fmBaseFreq=500, fmModSig=250, fmAmp=0.5, fmDelay;
   var amp,ampEnv, baseFreqEnv, harmSig, harmLPFreq, baseDelay;
   baseDelay=((y/128)*(baseDelayMax-baseDelayMin))+baseDelayMin;
   fmDelay=baseDelay/5;
   amp=((vel-96)/3).dbamp;
   harmLPFreq=((x/128)*(harmLPFreqMax-harmLPFreqMin))+harmLPFreqMin;
   ampEnv=amp*EnvGen.kr(Env.perc(attack,baseDelay,baseAmp),1,doneAction:2);
   baseFreqEnv=EnvGen.kr(Env.perc(attack,baseDelay,baseFreqMod,'sine'));
   harmSig=LPF.ar(Saw.ar(baseFreq+baseFreqEnv),harmLPFreq);
   Out.ar(out,Pan2.ar(ampEnv*harmSig,0));
   } ).store;

SynthDef.new("MidiDrum", { |vel=100, x=64, y=64, out=0|
   // bass drum patch with frequency shift.
   var baseFreq=50, baseDelayMin=0.1, baseDelayMax=3, baseAmp=1, attack=0.01;
   var baseFreqMod=1, harmLPFreqMin=baseFreq, harmLPFreqMax=baseFreq*10;
   var freqShiftMax=50;
   var fmBaseFreq=500, fmModSig=250, fmAmp=0.5, fmDelay;
   var amp,ampEnv, baseFreqEnv, harmSig, harmLPFreq, baseDelay, freqShift;
   baseDelay=0.7;//((y/128)*(baseDelayMax-baseDelayMin))+baseDelayMin;
   freqShift=(y/128)*(freqShiftMax);
   fmDelay=baseDelay/5;
   amp=((vel-96)/3).dbamp;
   harmLPFreq=((x/128)*(harmLPFreqMax-harmLPFreqMin))+harmLPFreqMin;
   ampEnv=amp*EnvGen.kr(Env.perc(attack,baseDelay,baseAmp),1,doneAction:2);
   baseFreqEnv=EnvGen.kr(Env.perc(attack,baseDelay,baseFreqMod,'sine'));
   harmSig=LPF.ar(FreqShift.ar(Saw.ar(baseFreq+baseFreqEnv),freqShift),harmLPFreq);
   Out.ar(out,Pan2.ar(ampEnv*harmSig,0));
   } ).store;

SynthDef.new("MidiDrum", { |vel=100, x=64, y=64, out=0|
   // bass drum patch with variable square wave / saw wave ratio.
   var baseFreq=200, baseDelayMin=0.1, baseDelayMax=3, baseAmp=1, attack=0.01;
   var baseFreqMod=1, harmLPFreqMin=baseFreq, harmLPFreqMax=baseFreq*10;
   var fmBaseFreq=500, fmModSig=250, fmAmp=0.5, fmDelay;
   var amp,ampEnv, baseFreqEnv, harmSig, harmLPFreq, baseDelay, sawRatio, oscSig;
   baseDelay=0.5; //((y/128)*(baseDelayMax-baseDelayMin))+baseDelayMin;
   fmDelay=baseDelay/5;
   amp=((vel-32)/3).dbamp;
   harmLPFreq=((x/128)*(harmLPFreqMax-harmLPFreqMin))+harmLPFreqMin;
   ampEnv=amp*EnvGen.kr(Env.perc(attack,baseDelay,baseAmp),1,doneAction:2);
   baseFreqEnv=EnvGen.kr(Env.perc(attack,baseDelay,baseFreqMod,'sine'));
   sawRatio=(y/128);
   oscSig=sawRatio*LFTri.ar(baseFreq+baseFreqEnv)+(1-sawRatio)*Saw.ar(baseFreq+baseFreqEnv);
   harmSig=LPF.ar(oscSig,harmLPFreq);
   Out.ar(out,Pan2.ar(ampEnv*harmSig,0));
   } ).store;

SynthDef.new("MidiDrum", { |vel=100, x=64, y=64, out=0|
   // snare drum from synth secrets (based on roland 909).
   var part1Freq=180, part1Amp=0.1, part2Freq=330, part2Amp=0.05, minDistortPow=0, maxDistortPow=3, partDelay=0.5;
   var attack=0.01, noiseLPFreq=10000, noiseHPFreq=2000, noiseAmp1=0.005, noiseAmp2Ratio=2;
   var minNoiseDelayRatio=0.2;
   var partSig, partEnv, amp, noiseDelay, noiseEnv, noiseSig1, noiseSig2, noiseSig;
   var distort;
   distort=10**(((x/128)*(maxDistortPow-minDistortPow))+minDistortPow);
   amp=((vel-64)/3).dbamp;   
   partEnv=amp*EnvGen.kr(Env.perc(attack,partDelay,1),1,doneAction:2);
   partSig=part1Amp*atan(SinOsc.ar(part1Freq, 0, distort))+part2Amp*atan(SinOsc.ar(part2Freq,0,distort));
   noiseSig1=noiseAmp1*LPF.ar(WhiteNoise.ar(1),noiseLPFreq);
   noiseSig2=(amp**0)*HPF.ar(noiseSig1*noiseAmp2Ratio,noiseHPFreq);
   noiseSig=(noiseSig1+noiseSig2);
   noiseDelay=partDelay*(((y/128)*(1-minNoiseDelayRatio))+minNoiseDelayRatio);
   noiseEnv=amp*EnvGen.kr(Env.perc(attack,noiseDelay,1),1,doneAction:0);
   Out.ar(out,Pan2.ar(partSig*partEnv+noiseSig*noiseEnv,0));
   } ).store;

SynthDef.new("MidiDrum", { |vel=100, x=64, y=64, out=0|
   // snare drum from synth secrets (based on roland 909).
   // different version with fixed noise delay and low pass filter.
   var part1Freq=180, part1Amp=0.1, part2Freq=330, part2Amp=0.05, minDistortPow=0.5, maxDistortPow=3, partDelay=0.7;
   var attack=0.01, noiseLPFreq=10000, noiseHPFreq=2000, noiseAmp1=0.005, noiseAmp2Ratio=2;
   var noiseDelay=0.4;
   var partSig, partEnv, amp, noiseEnv, noiseSig1, noiseSig2, noiseSig, outSig,lpFreq;
   var distort;
   distort=10**(((x/128)*(maxDistortPow-minDistortPow))+minDistortPow);
   amp=((vel/4)-28).dbamp;   
   partEnv=amp*EnvGen.kr(Env.perc(attack,partDelay,1),1,doneAction:2);
   partSig=part1Amp*atan(SinOsc.ar(part1Freq, 0, distort))+part2Amp*atan(SinOsc.ar(part2Freq,0,distort));
   noiseSig1=noiseAmp1*LPF.ar(WhiteNoise.ar(1),noiseLPFreq);
   noiseSig2=(amp**0)*HPF.ar(noiseSig1*noiseAmp2Ratio,noiseHPFreq);
   noiseSig=(noiseSig1+noiseSig2);
   noiseEnv=amp*EnvGen.kr(Env.perc(attack,noiseDelay,1),1,doneAction:0);
   lpFreq=((y*3/5)+51).midicps;
   outSig=RLPF.ar(partSig*partEnv+noiseSig*noiseEnv,lpFreq,0.5);
   Out.ar(out,Pan2.ar(outSig,0));
   } ).store;

SynthDef.new("MidiDrum", { |vel=100, x=64, y=64, out=0|
   // cymbal from synth secrets. 
   var fm1ModFreq=1047, fm1CarFreq=1481, fm1ModPW=0.2, fm1ModAmp=0.2;
   var fm2ModFreq=1109, fm2CarFreq=1049, fm2ModPW=0.2, fm2ModAmp=0.2;
   var fm3ModFreq=1175, fm3CarFreq=1480, fm3ModPW=0.2, fm3ModAmp=0.3;
   var hitBPFreq=1025, hitSweepAttack=0.0005, hitSweepRelease=0.075, hitSweepAmp=0.3;
   var ringHPFreq=2640, ringSweepAttack=0.3, ringSweepRelease=3, ringSweepAmp=0.7;
   var ampAttack=0.01, ampRelease=1;
   var fm1Sig, fm2Sig, fm3Sig, hitEnv, hitSig, fmMixSig, ringEnv, ringSig, ampEnv, amp;
   amp=((vel-113)/3).dbamp;
   fm1Sig=Pulse.ar((10**Pulse.ar(fm1ModFreq,0.3,fm1ModAmp))*fm1CarFreq);
   fm2Sig=Pulse.ar((10**Pulse.ar(fm2ModFreq,0.3,fm2ModAmp))*fm2CarFreq);
   fm3Sig=Saw.ar((10**Saw.ar(fm3ModFreq,fm3ModAmp))*fm3CarFreq);
   fmMixSig=fm1Sig+fm2Sig+fm3Sig;
   hitEnv=EnvGen.kr(Env.perc(hitSweepAttack,hitSweepRelease,1));
   hitSig=0.1*hitEnv*BPF.ar(fmMixSig,(10**(hitEnv*hitSweepAmp))*hitBPFreq,1);
   ringEnv=EnvGen.kr(Env.perc(ringSweepAttack,ringSweepRelease,ringSweepAmp));
   ringSig=HPF.ar(fmMixSig,(10**(0-ringEnv))*ringHPFreq);
   ampEnv=amp*EnvGen.kr(Env.perc(ampAttack,ampRelease,1),1,doneAction:2);
   Out.ar(out,Pan2.ar(ampEnv*(hitSig+ringSig),0) );
   } ).store;

// Trying out FFT stuff.

SynthDef.new("MidiDrum", { |vel=100, x=64, y=64,out=0|
	// complex conjugates
	var sndbuf= Buffer.readChannel(s, "/home/andy/Desktop/music/supercollider/samples/84001__sandyrb__KBSD_C42_VELOCITY9.wav", channels:0);
	var amp,sample,phase,sample2,chain,chain2,outchain,outsig,r;
   amp=((vel-96)/3).dbamp;
   r=x/127;
   phase=pi*y/127;
   sample=r*PlayBuf.ar(1,sndbuf,doneAction:2);
   sample2=(1-r)*PlayBuf.ar(1,sndbuf,doneAction:2);
   chain=FFT(LocalBuf(2048),sample);
   chain2=FFT(LocalBuf(2048),sample2);
   chain=PV_PhaseShift(chain,phase);
   chain2=PV_PhaseShift(chain2,phase);
   chain2=PV_Conj(chain2);
   outchain=PV_Add(chain,chain2);
   outsig=IFFT(outchain);
	Out.ar(out,amp*Pan2.ar(outsig, 0) );
	} ).store;

SynthDef.new("MidiDrum", { |vel=100, x=64, y=64,out=0|
	// morphing samples
	var sndbuf1= Buffer.readChannel(s, "/home/andy/Desktop/music/supercollider/samples/84001__sandyrb__KBSD_C42_VELOCITY9.wav", channels:0);
	var sndbuf2= Buffer.readChannel(s, "/home/andy/Desktop/music/supercollider/samples/100184__menegass__Rick_DRUM_BD_hard.wav", channels:0);
	var amp,sample1,phase,sample2,chain1,chain2,outchain,outsig,r;
   var noteMin=55; // 200Hz
	var noteMax=128;//66;
	var note=(y*(noteMax-noteMin)/127)+noteMin;
   amp=((vel-96)/3).dbamp;
   r=x/127;
   sample1=PlayBuf.ar(1,sndbuf1,doneAction:2);
   sample2=PlayBuf.ar(1,sndbuf2,doneAction:2);
   chain1=FFT(LocalBuf(2048),sample1);
   chain2=FFT(LocalBuf(2048),sample2);
   outchain=PV_Morph(chain1,chain2,r);
   outsig=LPF.ar(IFFT(outchain),note.midicps);
	Out.ar(out,amp*Pan2.ar(outsig, 0) );
	} ).store;

Synth(\MidiDrum3, []).play;

 { iRingz.ar(PinkNoise.ar(0.1), {exprand(300, 20000)}.dup(100)).mean }.play;

(
x = {
	var driver, cutoffenv, freqs, res;
	
	cutoffenv = EnvGen.ar(Env.perc(1, 5)) * 20000 + 10;
	driver = LPF.ar(WhiteNoise.ar(0.1), cutoffenv);
	freqsÂ  = {exprand(300, 20000)}.dup(100);
	resÂ  Â  = Ringz.ar(driver, freqs).mean.dup
}.play;
)

(
x = {
	var lodriver, locutoffenv, hidriver, hicutoffenv, freqs, res;
	
	locutoffenv = EnvGen.ar(Env.perc(0.25, 5)) * 20000 + 10;
	lodriver = LPF.ar(WhiteNoise.ar(0.1), locutoffenv);
	
	hicutoffenv = 10001 - (EnvGen.ar(Env.perc(1, 3)) * 10000);
	hidriver = HPF.ar(WhiteNoise.ar(0.1), hicutoffenv);
	hidriver = hidriver * EnvGen.ar(Env.perc(1, 2, 0.25));
	
	freqsÂ  = {exprand(300, 20000)}.dup(100);
	resÂ  Â  = Ringz.ar(lodriver + hidriver, freqs).mean.dup
}.play;
)
(
x = {
	var lodriver, locutoffenv, hidriver, hicutoffenv, freqs, res;
	
	locutoffenv = EnvGen.ar(Env.perc(0.5, 5)) * 20000 + 10;
	lodriver = LPF.ar(WhiteNoise.ar(0.1), locutoffenv);
	
	hicutoffenv = 10001 - (EnvGen.ar(Env.perc(1, 3)) * 10000);
	hidriver = HPF.ar(WhiteNoise.ar(0.1), hicutoffenv);
	hidriver = hidriver * EnvGen.ar(Env.perc(1, 2, 0.25));
	
	freqsÂ  = {exprand(300, 20000)}.dup(100);
	resÂ  Â  = Ringz.ar(lodriver + hidriver, freqs).mean;
	
	((res * 1) + (lodriver * 2)).dup;
}.play;
)

(
x = {
	var lodriver, locutoffenv, hidriver, hicutoffenv, freqs, res, r, bend, freqChange;
   bend=0.2;
	locutoffenv = EnvGen.ar(Env.perc(0.5, 5)) * 20000 + 10;
	lodriver = LPF.ar(WhiteNoise.ar(0.1), locutoffenv);
	
	hicutoffenv = 10001 - (EnvGen.ar(Env.perc(1, 3)) * 10000);
	hidriver = HPF.ar(WhiteNoise.ar(0.1), hicutoffenv);
	hidriver = hidriver * EnvGen.ar(Env.perc(1, 2, 0.25));
	r=exp(log(20000/300)/100);
   freqs = Array.geom(100,300,r);
   freqChange = Array.fill(20,{ arg i; sin(2*i) });
   freqs=freqs+((freqs*freqChange)*bend);
	//freqs = {exprand(300, 20000)}.dup(100);
	res = Ringz.ar(lodriver + hidriver, freqs).mean;
	
	((res * 1) + (lodriver * 2)).dup;
}.play;
)

	r=exp(log(20000/300)/100);

Array.geom(100,300,r);


{SinOsc.ar(150)}.play;

{ OnePole.ar(WhiteNoise.ar(0.5), 0.95) }.play

{LPF.ar(HPF.ar(Saw.ar(Saw.ar(250,250)+500),250),750)}.play

{ RLPF.ar(Pulse.ar([100,250],0.5,0.1), XLine.kr(8000,400,5), 0.05) }.play;

{ atan(SinOsc.ar(200,3.141/2)*2) }.play;
{ sin(SinOsc.ar(200,3.141/2)*5) }.play;
{ SinOsc.ar(200) }.play;

Array.fib(20,2,32).postln;

x=Array.geom(20,1,2).postln;
y=Array.fill(20,{ arg i; sin(2*i) }).postln;
x+y;
x+((x*y)/10);
x*y;

{ DynKlank.ar(`[[800, 1071, 1153, 1723], nil, [1,1, 1, 1]], EnvGen.kr(Env.perc(0,0.01,1,'linear'))*Impulse.ar(50, 0, 0.1)) }.play;


{ DynKlank.ar(`[[200, 671, 1153, 1723], nil, [1, 1, 1, 1]], PinkNoise.ar([0.007,0.007])) }.play;


{ DynKlank.ar(`[[800, 1071, 1353, 1723], nil, [1, 1, 1, 1]], Dust.ar(8, 0.1)) }.play;

10.do({|i| i.postln;});
